WordPress 4.1
[autoinstalls/wordpress.git] / wp-admin / update.php
index b89ada27deeeeee7185e050d1a166fd35e910fab..6ded7a7d7a7c39a49d6311d89f49917ffe9a629d 100644 (file)
@@ -12,7 +12,7 @@ if ( ! defined( 'IFRAME_REQUEST' ) && isset( $_GET['action'] ) && in_array( $_GE
 /** WordPress Administration Bootstrap */
 require_once( dirname( __FILE__ ) . '/admin.php' );
 
-include_once ABSPATH . 'wp-admin/includes/class-wp-upgrader.php';
+include_once( ABSPATH . 'wp-admin/includes/class-wp-upgrader.php' );
 
 if ( isset($_GET['action']) ) {
        $plugin = isset($_REQUEST['plugin']) ? trim($_REQUEST['plugin']) : '';
@@ -37,7 +37,7 @@ if ( isset($_GET['action']) ) {
                $url = 'update.php?action=update-selected&plugins=' . urlencode(implode(',', $plugins));
                $nonce = 'bulk-update-plugins';
 
-               wp_enqueue_script('jquery');
+               wp_enqueue_script( 'updates' );
                iframe_header();
 
                $upgrader = new Plugin_Upgrader( new Bulk_Plugin_Upgrader_Skin( compact( 'nonce', 'url' ) ) );
@@ -54,6 +54,8 @@ if ( isset($_GET['action']) ) {
                $title = __('Update Plugin');
                $parent_file = 'plugins.php';
                $submenu_file = 'plugins.php';
+
+               wp_enqueue_script( 'updates' );
                require_once(ABSPATH . 'wp-admin/admin-header.php');
 
                $nonce = 'upgrade-plugin_' . $plugin;
@@ -84,7 +86,8 @@ if ( isset($_GET['action']) ) {
 
                        error_reporting( E_CORE_ERROR | E_CORE_WARNING | E_COMPILE_ERROR | E_ERROR | E_WARNING | E_PARSE | E_USER_ERROR | E_USER_WARNING | E_RECOVERABLE_ERROR );
                        @ini_set('display_errors', true); //Ensure that Fatal errors are displayed.
-                       include(WP_PLUGIN_DIR . '/' . $plugin);
+                       wp_register_plugin_realpath( WP_PLUGIN_DIR . '/' . $plugin );
+                       include( WP_PLUGIN_DIR . '/' . $plugin );
                }
                iframe_footer();
        } elseif ( 'install-plugin' == $action ) {
@@ -92,7 +95,7 @@ if ( isset($_GET['action']) ) {
                if ( ! current_user_can('install_plugins') )
                        wp_die( __( 'You do not have sufficient permissions to install plugins on this site.' ) );
 
-               include_once ABSPATH . 'wp-admin/includes/plugin-install.php'; //for plugins_api..
+               include_once( ABSPATH . 'wp-admin/includes/plugin-install.php' ); //for plugins_api..
 
                check_admin_referer('install-plugin_' . $plugin);
                $api = plugins_api('plugin_information', array('slug' => $plugin, 'fields' => array('sections' => false) ) ); //Save on a bit of bandwidth.
@@ -120,8 +123,9 @@ if ( isset($_GET['action']) ) {
 
        } elseif ( 'upload-plugin' == $action ) {
 
-               if ( ! current_user_can('install_plugins') )
+               if ( ! current_user_can( 'upload_plugins' ) ) {
                        wp_die( __( 'You do not have sufficient permissions to install plugins on this site.' ) );
+               }
 
                check_admin_referer('plugin-upload');
 
@@ -153,6 +157,7 @@ if ( isset($_GET['action']) ) {
                check_admin_referer('upgrade-theme_' . $theme);
 
                wp_enqueue_script( 'customize-loader' );
+               wp_enqueue_script( 'updates' );
 
                $title = __('Update Theme');
                $parent_file = 'themes.php';
@@ -184,7 +189,7 @@ if ( isset($_GET['action']) ) {
                $url = 'update.php?action=update-selected-themes&themes=' . urlencode(implode(',', $themes));
                $nonce = 'bulk-update-themes';
 
-               wp_enqueue_script('jquery');
+               wp_enqueue_script( 'updates' );
                iframe_header();
 
                $upgrader = new Theme_Upgrader( new Bulk_Theme_Upgrader_Skin( compact( 'nonce', 'url' ) ) );
@@ -196,9 +201,9 @@ if ( isset($_GET['action']) ) {
                if ( ! current_user_can('install_themes') )
                        wp_die( __( 'You do not have sufficient permissions to install themes on this site.' ) );
 
-               include_once ABSPATH . 'wp-admin/includes/theme-install.php'; //for themes_api..
+               include_once( ABSPATH . 'wp-admin/includes/theme-install.php' ); //for themes_api..
 
-               check_admin_referer('install-theme_' . $theme);
+               check_admin_referer( 'install-theme_' . $theme );
                $api = themes_api('theme_information', array('slug' => $theme, 'fields' => array('sections' => false, 'tags' => false) ) ); //Save on a bit of bandwidth.
 
                if ( is_wp_error($api) )
@@ -223,8 +228,9 @@ if ( isset($_GET['action']) ) {
 
        } elseif ( 'upload-theme' == $action ) {
 
-               if ( ! current_user_can('install_themes') )
+               if ( ! current_user_can( 'upload_themes' ) ) {
                        wp_die( __( 'You do not have sufficient permissions to install themes on this site.' ) );
+               }
 
                check_admin_referer('theme-upload');
 
@@ -252,6 +258,15 @@ if ( isset($_GET['action']) ) {
                include(ABSPATH . 'wp-admin/admin-footer.php');
 
        } else {
-               do_action('update-custom_' . $action);
+               /**
+                * Fires when a custom plugin or theme update request is received.
+                *
+                * The dynamic portion of the hook name, `$action`, refers to the action
+                * provided in the request for wp-admin/update.php. Can be used to
+                * provide custom update functionality for themes and plugins.
+                *
+                * @since 2.8.0
+                */
+               do_action( "update-custom_{$action}" );
        }
 }